<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>PySpottedUnipd: /home/stefano/Coding/Python/projects/spotted-unipd/pyspottedunipd/ngrams/ngram.py Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">PySpottedUnipd
   &#160;<span id="projectnumber">0.0.2</span>
   </div>
   <div id="projectbrief">Figure out how you can find your sweet half or how to get attention and get liked in one of the most popular @Unipd facebook pages.</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('ngram_8py_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">ngram.py</div>  </div>
</div><!--header-->
<div class="contents">
<a href="ngram_8py.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno"><a class="line" href="namespacepyspottedunipd_1_1ngrams_1_1ngram.html">    1</a></span>&#160;<span class="keyword">from</span> collections <span class="keyword">import</span> Counter</div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="keyword">from</span> random <span class="keyword">import</span> choice</div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="keyword">import</span> re</div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;</div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_cup.html">    6</a></span>&#160;<span class="keyword">class </span><a class="code" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_cup.html">Cup</a>:</div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;    <span class="stringliteral">&quot;&quot;&quot; A class defining a cup that will hold the words that we will pull out &quot;&quot;&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;</div><div class="line"><a name="l00009"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_cup.html#a5fd14941fe5d58d594701f7a2f7060c2">    9</a></span>&#160;    <span class="keyword">def </span><a class="code" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_cup.html#a5fd14941fe5d58d594701f7a2f7060c2">__init__</a>(self):</div><div class="line"><a name="l00010"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_cup.html#ad9ab0194908366854037a88fc668695b">   10</a></span>&#160;        self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_cup.html#ad9ab0194908366854037a88fc668695b">next_word</a> = Counter()  <span class="comment"># will keep track of how many times a word appears in a cup</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div><div class="line"><a name="l00012"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_cup.html#a827d1d287e3e81c7e32c3ad9621e7c02">   12</a></span>&#160;    <span class="keyword">def </span><a class="code" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_cup.html#a827d1d287e3e81c7e32c3ad9621e7c02">add_next_word</a>(self, word):</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;        <span class="stringliteral">&quot;&quot;&quot; Used to add words to the cup and keep track of how many times we see it &quot;&quot;&quot;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;        self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_cup.html#ad9ab0194908366854037a88fc668695b">next_word</a>[word] += 1</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div><div class="line"><a name="l00018"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram.html">   18</a></span>&#160;<span class="keyword">class </span><a class="code" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram.html">NGram</a>:</div><div class="line"><a name="l00019"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram.html#abf0644a01745c4a01119a7b1d11304b0">   19</a></span>&#160;    <span class="keyword">def </span><a class="code" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram.html#abf0644a01745c4a01119a7b1d11304b0">make_cups</a>(self, order, string):</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        <span class="stringliteral">&quot;&quot;&quot; Get a string of input text and make all the unique cups with the different words in it &quot;&quot;&quot;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        cups = dict()</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        words = re.findall(<span class="stringliteral">r&quot;([\w]+)&quot;</span>, string)</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;        token = []</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;        next_word = <span class="stringliteral">&#39;&#39;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;        <span class="keywordflow">for</span> i <span class="keywordflow">in</span> range(len(words) - order):</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;            token = []</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;            next_word = words[i + order]</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;            <span class="keywordflow">for</span> j <span class="keywordflow">in</span> range(order):</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;                token.append(words[i + j])</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;            <span class="comment"># create a cup if we&#39;ve never seen this token before</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;            <span class="keywordflow">if</span> tuple(token) <span class="keywordflow">not</span> <span class="keywordflow">in</span> cups:</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;                cups[tuple(token)] = <a class="code" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_cup.html">Cup</a>()</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;                cups[tuple(token)].add_next_word(next_word)</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;            <span class="keywordflow">else</span>:</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;                cups[tuple(token)].add_next_word(next_word)</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;        <span class="keywordflow">return</span> cups</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram.html#ae2cb27fa1bf81988f2b9a08baac50c22">   40</a></span>&#160;    <span class="keyword">def </span><a class="code" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram.html#ae2cb27fa1bf81988f2b9a08baac50c22">print_cups</a>(self, cups):</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        <span class="stringliteral">&quot;&quot;&quot; You can use this to see what cups there are and the words inside of it &quot;&quot;&quot;</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        <span class="keywordflow">for</span> token <span class="keywordflow">in</span> list(cups.keys()):</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;            print(<span class="stringliteral">&quot;key %s : nextword %s&quot;</span> % (token, cups[token].next_word))</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram.html#aca29c666e2d50648115c9e5db8044276">   45</a></span>&#160;    <span class="keyword">def </span><a class="code" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram.html#aca29c666e2d50648115c9e5db8044276">topword</a>(self, n, cup):</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        <span class="stringliteral">&quot;&quot;&quot; A function that picks the top words in a cup. I realized I could&#39;ve just randomly picked from a list of words </span></div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="stringliteral">            but instead a made a Counter() object of words to keep track of them</span></div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="stringliteral">        &quot;&quot;&quot;</span></div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        <span class="comment"># reverse sort based on values</span></div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        temp = list(reversed(sorted(cup.next_word, key=cup.next_word.get)))</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        <span class="keywordflow">if</span> len(temp[:n]) &gt; 0:</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;            <span class="keywordflow">return</span> choice(temp[:n])  <span class="comment"># random element from the temp list</span></div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        <span class="keywordflow">else</span>:</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;            <span class="keywordflow">return</span> <span class="stringliteral">&quot;&quot;</span></div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram.html#a7e17271847dc9d63a331db41d52c272e">   56</a></span>&#160;    <span class="keyword">def </span><a class="code" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram.html#a7e17271847dc9d63a331db41d52c272e">generate_from_file</a>(self, order, filename, number_of_words):</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        <span class="stringliteral">&quot;&quot;&quot; Generate words based on a text file &quot;&quot;&quot;</span></div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        <span class="comment"># put file in one big string</span></div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        with open(filename, <span class="stringliteral">&#39;r&#39;) as f:</span></div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="stringliteral">            string = f.read()</span></div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="stringliteral"></span></div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="stringliteral">        string = re.sub(&#39;[,\.?&quot;-\&#39;!:;]&#39;</span>, <span class="stringliteral">&#39;&#39;</span>, string)</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        cups = self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram.html#abf0644a01745c4a01119a7b1d11304b0">make_cups</a>(order, string)</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        first_token = choice(list(cups.keys()))  <span class="comment"># random first token</span></div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        this_token = first_token</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        generated_words = []</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        generated_words += list(this_token)</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        next_word = <span class="stringliteral">&quot;&quot;</span>  <span class="comment"># first next word is blank</span></div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        <span class="keywordflow">for</span> i <span class="keywordflow">in</span> range(number_of_words):</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;            next_word = self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram.html#aca29c666e2d50648115c9e5db8044276">topword</a>(1, cups[this_token])</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;            temp = list(this_token)</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;            temp.pop(0)  <span class="comment"># remove first word in token</span></div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;            temp.append(next_word)  <span class="comment"># add new word to the token</span></div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;            next_token = tuple(temp)</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;            this_token = next_token</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;            generated_words += [next_word]</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        <span class="keywordflow">return</span> <span class="stringliteral">&#39; &#39;</span>.join(generated_words)</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;</div><div class="line"><a name="l00086"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram.html#a1ce3d2690c4f558f135d4255e014e616">   86</a></span>&#160;    <span class="keyword">def </span><a class="code" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram.html#a1ce3d2690c4f558f135d4255e014e616">generate_from_string</a>(self, order, string, number_of_words):</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        <span class="stringliteral">&quot;&quot;&quot; Generate words based on a string &quot;&quot;&quot;</span></div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        string = re.sub(<span class="stringliteral">&#39;[,\.?&quot;-\&#39;!:;]&#39;</span>, <span class="stringliteral">&#39;&#39;</span>, string)</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        cups = {}</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        cups = self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram.html#abf0644a01745c4a01119a7b1d11304b0">make_cups</a>(order, string)</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        first_token = choice(list(cups.keys()))  <span class="comment"># random first token</span></div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        this_token = first_token</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        generated_words = []</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        generated_words += list(this_token)</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        next_word = <span class="stringliteral">&quot;&quot;</span>  <span class="comment"># first next_word is blank</span></div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        <span class="keywordflow">for</span> i <span class="keywordflow">in</span> range(1, number_of_words):</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;            <span class="comment"># if the name of the token exists</span></div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;            <span class="keywordflow">if</span> this_token <span class="keywordflow">in</span> cups:</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;                next_word = self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram.html#aca29c666e2d50648115c9e5db8044276">topword</a>(2, cups[this_token])</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;            <span class="keywordflow">else</span>:</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;                this_token = choice(list(cups.keys()))  <span class="comment"># random token</span></div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;                next_word = self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram.html#aca29c666e2d50648115c9e5db8044276">topword</a>(2, cups[this_token])</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;            temp = list(this_token)</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;            temp.pop(0)  <span class="comment"># remove first word in token</span></div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;            temp.append(next_word)  <span class="comment"># add new word to the end of the token</span></div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;            next_token = tuple(temp)</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;            this_token = next_token</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;            generated_words += [next_word]</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;        print(<span class="stringliteral">&#39; &#39;</span>.join(generated_words))</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;</div><div class="line"><a name="l00118"></a><span class="lineno"><a class="line" href="namespacepyspottedunipd_1_1ngrams_1_1ngram.html#ada7b76bbd5156d9f773e20dcd91699bb">  118</a></span>&#160;<span class="keyword">def </span><a class="code" href="namespacepyspottedunipd_1_1ngrams_1_1ngram.html#ada7b76bbd5156d9f773e20dcd91699bb">main</a>():</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    rounds = 10</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    ngram = <a class="code" href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram.html">NGram</a>()</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <span class="keywordflow">for</span> i <span class="keywordflow">in</span> range(2, rounds):</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        print(<span class="stringliteral">&quot;\n&quot;</span>, <span class="stringliteral">&quot;------&quot;</span>, i, <span class="stringliteral">&quot;------&quot;</span>, <span class="stringliteral">&quot;\n&quot;</span>)</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        s = ngram.generate_from_file(order=i, filename=<span class="stringliteral">&#39;msg.txt&#39;</span>, number_of_words=150)</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;        s = s.lower()</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        a = s.split(<span class="stringliteral">&quot;spotto&quot;</span>)</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;        a = [<span class="stringliteral">&quot;spotto &quot;</span> + x.strip() <span class="keywordflow">for</span> x <span class="keywordflow">in</span> a]</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;        <span class="keywordflow">for</span> x <span class="keywordflow">in</span> a:</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;            print(x, <span class="stringliteral">&quot;\n&quot;</span>)</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;<span class="keywordflow">if</span> __name__ == <span class="stringliteral">&#39;__main__&#39;</span>:</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    <a class="code" href="namespacepyspottedunipd_1_1ngrams_1_1ngram.html#ada7b76bbd5156d9f773e20dcd91699bb">main</a>()</div><div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram_html_a7e17271847dc9d63a331db41d52c272e"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram.html#a7e17271847dc9d63a331db41d52c272e">pyspottedunipd.ngrams.ngram.NGram.generate_from_file</a></div><div class="ttdeci">def generate_from_file(self, order, filename, number_of_words)</div><div class="ttdef"><b>Definition:</b> <a href="ngram_8py_source.html#l00056">ngram.py:56</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram_html_ae2cb27fa1bf81988f2b9a08baac50c22"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram.html#ae2cb27fa1bf81988f2b9a08baac50c22">pyspottedunipd.ngrams.ngram.NGram.print_cups</a></div><div class="ttdeci">def print_cups(self, cups)</div><div class="ttdef"><b>Definition:</b> <a href="ngram_8py_source.html#l00040">ngram.py:40</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_cup_html"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_cup.html">pyspottedunipd.ngrams.ngram.Cup</a></div><div class="ttdef"><b>Definition:</b> <a href="ngram_8py_source.html#l00006">ngram.py:6</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram_html_a1ce3d2690c4f558f135d4255e014e616"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram.html#a1ce3d2690c4f558f135d4255e014e616">pyspottedunipd.ngrams.ngram.NGram.generate_from_string</a></div><div class="ttdeci">def generate_from_string(self, order, string, number_of_words)</div><div class="ttdef"><b>Definition:</b> <a href="ngram_8py_source.html#l00086">ngram.py:86</a></div></div>
<div class="ttc" id="namespacepyspottedunipd_1_1ngrams_1_1ngram_html_ada7b76bbd5156d9f773e20dcd91699bb"><div class="ttname"><a href="namespacepyspottedunipd_1_1ngrams_1_1ngram.html#ada7b76bbd5156d9f773e20dcd91699bb">pyspottedunipd.ngrams.ngram.main</a></div><div class="ttdeci">def main()</div><div class="ttdef"><b>Definition:</b> <a href="ngram_8py_source.html#l00118">ngram.py:118</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_cup_html_ad9ab0194908366854037a88fc668695b"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_cup.html#ad9ab0194908366854037a88fc668695b">pyspottedunipd.ngrams.ngram.Cup.next_word</a></div><div class="ttdeci">next_word</div><div class="ttdef"><b>Definition:</b> <a href="ngram_8py_source.html#l00010">ngram.py:10</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_cup_html_a827d1d287e3e81c7e32c3ad9621e7c02"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_cup.html#a827d1d287e3e81c7e32c3ad9621e7c02">pyspottedunipd.ngrams.ngram.Cup.add_next_word</a></div><div class="ttdeci">def add_next_word(self, word)</div><div class="ttdef"><b>Definition:</b> <a href="ngram_8py_source.html#l00012">ngram.py:12</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram_html_abf0644a01745c4a01119a7b1d11304b0"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram.html#abf0644a01745c4a01119a7b1d11304b0">pyspottedunipd.ngrams.ngram.NGram.make_cups</a></div><div class="ttdeci">def make_cups(self, order, string)</div><div class="ttdef"><b>Definition:</b> <a href="ngram_8py_source.html#l00019">ngram.py:19</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram_html_aca29c666e2d50648115c9e5db8044276"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram.html#aca29c666e2d50648115c9e5db8044276">pyspottedunipd.ngrams.ngram.NGram.topword</a></div><div class="ttdeci">def topword(self, n, cup)</div><div class="ttdef"><b>Definition:</b> <a href="ngram_8py_source.html#l00045">ngram.py:45</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_cup_html_a5fd14941fe5d58d594701f7a2f7060c2"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_cup.html#a5fd14941fe5d58d594701f7a2f7060c2">pyspottedunipd.ngrams.ngram.Cup.__init__</a></div><div class="ttdeci">def __init__(self)</div><div class="ttdef"><b>Definition:</b> <a href="ngram_8py_source.html#l00009">ngram.py:9</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram_html"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1ngram_1_1_n_gram.html">pyspottedunipd.ngrams.ngram.NGram</a></div><div class="ttdef"><b>Definition:</b> <a href="ngram_8py_source.html#l00018">ngram.py:18</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_cadfa51a49c9afcc310fa35ae151bb00.html">pyspottedunipd</a></li><li class="navelem"><a class="el" href="dir_99175f8b6c783221f605e721a02ede92.html">ngrams</a></li><li class="navelem"><a class="el" href="ngram_8py.html">ngram.py</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
